

.equ baudrateval=11;			value for ubrr to set baudrate

ser_getbyte_poll:
; ************************************************************
;if there was a char,  r17=1 and r18 contains char
;if there was nothing, r17=0 and r18 is undefined
; ************************************************************			
	push r19;
	ldi r18,16;
	out ucsrb,r18;
	ldi r17,0;
	in r18,ucsra;	  	check if byte is received !
	andi r18,128;
	ldi r19,128;
	cp r19,r18;		
	brne ser_getbyte_poll_end;	
	in r18,$0C;
     	ldi r17,1;
	ser_getbyte_poll_end:
	pop r19;
	ret;
	
	
ser_getbyteto_poll:
; ************************************************************
;timeout time in r20, 1=4000 clks=0.5ms@8MHz
;if there was a char,  r17=1 and r18 contains char
;if there was nothing, r17=0 and r18 is undefined
;
; ************************************************************			
	
	push r19;
	ldi r19,255;
	ldi r18,16;
	out ucsrb,r18;		set uart rec
	ldi r17,0;
	subi r16,1;
	sbci r16,0;
	ser_getbyteto_poll_1:
	subi r19,1;
	sbci r20,0;
	brcs ser_getbyteto_poll_end; 
	
	in r18,ucsra;	  	check if byte is received !
	andi r18,128;
	cpi r18,128;		
	brne ser_getbyteto_poll_1;	
	in r18,$0C;
     	ldi r17,1;
	ser_getbyteto_poll_end:
	pop r19;
	ret;
	
; ************************************************************
;  subroutine inits uart	
;  
;  baudrate= fclk/(16*(ubrr+1))
;  set uart to transmitt data
;  no int
; ************************************************************
ser_inituart_poll:
	ldi r16,baudrateval;
	out UBRR,r16;
	ldi r16,8;
	out ucsrb,r16;	set no int, transmiting      8=transmitt, 16=receive
	ret;
ser_send8bcd_poll:
;************************************************************
;Subroutine send ro..r2 to rs232
;no int, polling
;************************************************************	
mov r16,r2;
rcall ser_sendbyte_poll;

mov r16,r1;
rcall ser_sendbyte_poll;

mov r16,r0;
rcall ser_sendbyte_poll;


ret;

;*******************************************************************
; Sende Text aus Mem. an Display
; Load ZH und ZL mit Adresse von Text
;Needs Z
;*******************************************************************
send_txt_ser:
	
	push r0;
	lpm				; Load byte from program memory into r0
	tst	r0			; Check if we've reached the end of the message
	breq	send_txt_ser_quit	; If so, quit
	mov     r16,r0			;
	rcall   ser_sendbyte_poll	; Put the character 
	adiw	ZL,1			; Increase Z registers
	rjmp	send_txt_ser		;


send_txt_ser_quit:
pop r0;
ret;
ser_sendbyte_poll:
; ************************************************************
;Subroutine send byte to rs232
;byte to send has to be in r16
;no int, polling
; ************************************************************	
	push r19;
	push r18;

	ldi r18,8;
	out ucsrb,r18;
	out udr,r16;	 	send byte to data-reg 	
       
  ser_sendwait: 
	
	in r19,ucsra;	  	check if byte is send !
	andi r19,32;
	ldi r18,32;
	cp r19,r18;		
	brne ser_sendwait;		no -> wait
	
	ldi r18,64;
     	out ucsra,r18;
     	pop r18;
     	pop r19;
ret;

ser_setuart_rec:
	push r18;
	ldi r18,16;
	out ucsrb,r18;
	pop r18;
	ret;
ser_setuart_trans:
	push r18;	
	ldi r18,8;
	out ucsrb,r18;
	pop r18;
	ret;





	
	
	

	
	

